@page "/settings"

@using AntDesign
@using AntDesign.TableModels
@using System.Collections.Generic
@using System.ComponentModel
@using System.Linq
@using System.Text;
@using System.Net;
@using FIOWebServer.Models
@using FIOWebServer.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState

@implements IDisposable

<h1>Settings</h1>

<FIOWebServer.Components.LoadingWrapper RequiresAuth="true" @bind-ProgressCount="CurrentProgress" TotalProgress=6>
<h2>Found a bug?  Have a request?</h2>
    <MatButtonLink Raised="true" Class="mdc-toast-info" Href="https://gitlab.com/fnar/fio/support/-/issues" Target="_blank" >Open an Issue</MatButtonLink>

    <br/>
    <br/>
    <hr>

    <h2>User Reset</h2>
    <Modal Title="Are you sure?"
           Visible="ResetAllDataDlgVisible"
           OnOk="@ResetAllDataOnOk"
           OnCancel="@ResetAllDataOnCancel"
           Draggable="true">
    </Modal>
    <em>This will reset data specific for your user.</em><br/>
    <em>Use this if you have some bad data due to hydration timeouts, for example. Or if you COLIQ'd.</em><br/>
    <em>You should do <a href="/setup">setup</a> again after resetting.</em>
    <br/><br/>
    <MatButton Raised="true" Class="mdc-toast-info" OnClick="@(() => { ResetAllDataDlgVisible = true; })">Reset My Data</MatButton>

    <br/>
    <br/>
    <hr>

    <h2>
        Set Discord Username
        @if (!String.IsNullOrEmpty(DiscordId))
        {
            <Popover Placement="@Placement.RightTop">
                <ContentTemplate>
                    Username is currently set to <code>@DiscordId</code>
                </ContentTemplate>
                <ChildContent>
                    <MatIcon Icon="check_circle_outline" />
                </ChildContent>
            </Popover>
        }
        else
        {
            <Popover Placement="@Placement.RightTop">
                <ContentTemplate>
                    <p>Currently Unset</p>
                    <p>Your discord username is your unique username used across all servers</p>
                </ContentTemplate>
                <ChildContent>
                    <MatIcon Icon="block" />
                </ChildContent>
            </Popover>
        }
    </h2>
    @if (SetDiscordIdDlgVisible)
    {
        <Modal Title="Set Discord Id"
               Visible="@SetDiscordIdDlgVisible"
               OnOk="@SetDiscordIdOnOk"
               OnCancel="@SetDiscordIdOnCancel"
               Draggable="true">
            <div>
                <MatTextField @bind-Value="@DiscordId" Label="Discord UserName" FullWidth="true" Required="true" />
            </div>
        </Modal>
    }
    <MatButton Raised="true" Class="mdc-toast-info" OnClick="@(() => { SetDiscordIdDlgVisible = true; })">Set Discord UserName</MatButton>

    <br/>
    <br/>
    <hr>

    <h2>Change Password</h2>
    @if (ChangePasswordDlgVisible)
    {
    <Modal Title="Change Password"
           Visible="@ChangePasswordDlgVisible"
           OnOk="@ChangePasswordOnOk"
           OnCancel="@ChangePasswordOnCancel"
           Draggable="true">
        <div>
            <MatTextField @bind-Value="@OldPassword" Label="Old Password" FullWidth="true" Required="true" Type="password"/>      
            <br/><br/>                                                                          
            <MatTextField @bind-Value="@NewPassword" Label="New Password" FullWidth="true" Required="true" Type="password"/>         
            <br/>                                                                          
            <MatTextField @bind-Value="@NewPassword2" Label="Confirm New Password" FullWidth="true" Required="true" Type="password"/> 
        </div>
    </Modal>
    }
    <MatButton Raised="true" Class="mdc-toast-info" OnClick="@(() => { ChangePasswordDlgVisible = true; })">Change Password</MatButton>

    <br/>
    <br/>
    <hr>

    <h2>API Keys</h2>
    <MatButton Raised="true" Class="mdc-toast-info" OnClick="@(() => { APIKeyAllowWrites = false; CreateAPIKeyDialogVisible = true; })">Create API Key</MatButton>
    @if (CreateAPIKeyDialogVisible)
    {
    <Modal Title="Create API Key"
            Visible="@CreateAPIKeyDialogVisible"
            OnOk="@CreateAPIKeyOnOk"
            OnCancel="@CreateAPIKeyOnCancel"
            Draggable="true">
        <div>
            <MatTextField @bind-Value="@APIKeyApplication" Label="Application" FullWidth="true" Required="true"/>
            <MatTextField @bind-Value="@APIKeyPassword" Label="FIO Account Password" FullWidth="true" Required="true" Type="password"/>
            <br/>
            <Checkbox Checked="@APIKeyAllowWrites" CheckedChange="@ToggleAPIKeyAllowWritesChecked">Allow Writes</Checkbox>
            <Popover Placement="@Placement.RightTop" Title="Warning">
                <ContentTemplate>
                    Allowing writes allows anyone using this APIKey to modify your data. You should only use this if you know what you are doing.
                </ContentTemplate>
                <ChildContent>
                    <MatIcon Style="font-size: 16px; color: orangered" Icon="warning"/>
                </ChildContent>
            </Popover>
        </div>
    </Modal>
    }

    @if (DeleteAPIKeyDialogVisible)
    {
    <Modal Title="Delete API Key"
           Visible="@DeleteAPIKeyDialogVisible"
           OnOk="@DeleteAPIKeyOnOk"
           OnCancel="@DeleteAPIKeyOnCancel"
           Draggable="true">
        <div>
            <MatTextField @bind-Value="@APIKeyPassword" Label="FIO Account Password" FullWidth="true" Required="true" Type="password"/>
        </div>
    </Modal>
    }

    <Table @ref="APIKeyTable"
           TItem="JsonAuthAPIKeyPayload"
           Size="@TableSize.Small"
           Bordered="true"
           PageSize="10"
           DataSource="@APIKeys">
            <Column @bind-Field="@context.Application" Title="Application"/>
            <Column @bind-Field="@context.AuthAPIKey" Title="APIKey"/>
            <Column @bind-Field="@context.AllowWrites" Title="Allow Writes">
                <AntDesign.Switch @bind-Value="@context.AllowWrites" Disabled/>
            </Column>
            <Column @bind-Field="@context.LastAccessTime" Title="Last Access Timestamp"/>
            <ActionColumn>
                <Space>
                       <SpaceItem><Button Danger OnClick="@(() => { APIKeyGuid = @context.AuthAPIKey; DeleteAPIKeyDialogVisible = true;})">Delete</Button></SpaceItem>
                </Space>
            </ActionColumn>
    </Table>

    <h2>Groups</h2>
    <em>
        Create up to 20 groups that you can share with others.
    </em>
    <br/>
    <MatButton Raised="true" Class="mdc-toast-info" OnClick="@(() => { CreateOrEditGroupDialogVisible = true; })">Create Group</MatButton>
    <Table @ref="GroupTable"
           TItem="GroupPayload"
           Size="@TableSize.Small"
           Bordered="true"
           PageSize="10"
           DataSource="@Groups">
            <ActionColumn>
                <Space>
                    <SpaceItem>
                        <Button OnClick="@(() => {OnClickGroupHubButton(@context);})">GroupHub</Button>
                    </SpaceItem>
                    <SpaceItem>
                        <Button OnClick="@(() => {OnClickBurnButton(@context);})">Burn</Button>
                    </SpaceItem>
                </Space>
            </ActionColumn>
            <Column @bind-Field="@context.GroupModelId" Title="Id"/>
            <Column @bind-Field="@context.GroupName" Title="Name"/>
            <ActionColumn>
                <Space>
                    <SpaceItem>
                        <Button OnClick="@(() => { OnClickEdit(@context); })">Edit</Button>
                    </SpaceItem>
                </Space>
            </ActionColumn>
            <ActionColumn>
                <Space>
                    <SpaceItem>
                        <Button Danger Disabled="@(!IsGroupOwner(@context))" OnClick="@(() => { OnClickDelete(@context); })">Delete</Button>
                    </SpaceItem>
                </Space>
            </ActionColumn>
     </Table>

     @if (CreateOrEditGroupDialogVisible)
     {
      <Modal Title="@(GroupId == null ? "Create Group" : $"Edit {GroupId}")"
            Visible="@CreateOrEditGroupDialogVisible"
            OnOk="@CreateOrEditGroupOnOk"
            OnCancel="@CreateOrEditGroupOnCancel"
            Draggable="true">
        <div>
            <MatTextField @bind-Value="@GroupName" Label="Group Name" FullWidth="true" Required="true"/>
            <br/><br/>
            <em>Members</em>
            <Select Mode="multiple" Placeholder="Select Users" EnableSearch AllowClear @bind-Values="@GroupUsers" HideSelected TItemValue="string" TItem="string">
                <SelectOptions>
                    @foreach(var GroupAvailableUser in AllUsers)
                    {
                        <SelectOption TItemValue="string" TItem="string" Value="@GroupAvailableUser" Label="@GroupAvailableUser"/>
                    }
                </SelectOptions>
            </Select>
            <br/><br/>
            <em>Admins</em>
            <Select Mode="multiple" Placeholder="Select Admins" EnableSearch AllowClear @bind-Values="@GroupAdmins" HideSelected TItemValue="string" TItem="string">
                <SelectOptions>
                    @foreach(var GroupUser in GroupUsers)
                    {
                        <SelectOption TItemValue="string" TItem="string" Value="@GroupUser" Label="@GroupUser"/>
                    }
                    </SelectOptions>
            </Select>
        </div>
     </Modal>
     }

     @if (DeleteGroupDialogVisible)
     {
    <Modal Title="Delete Group"
            Visible="@DeleteGroupDialogVisible"
            OnOk="@DeleteGroupOnOk"
            OnCancel="@DeleteGroupOnCancel"
            Draggable="true">
        <div>
            <em>Are you sure you wish to delete group '@(GroupName)'?</em>
        </div>
    </Modal>
     }
        
    <h2>Permissions</h2>
    <em>
        Add users so they can view your game data.  Some pages require multiple permissions to be provided before they function.<br/>
        Username "*" indicates <b>all</b> users, so you can make your data visible with everyone if you wish.
    </em>
    @if (PermissionUserDrawerVisible)
    {
    <div>
    <Drawer Visible="@PermissionUserDrawerVisible" Placement="right" Title='("Select User")' OnClose="@(() => { PermissionUserDrawerVisible = false; OnPermissionUserSelectionClosed(); })">
        @if(PermissionRemainingUsers.Count > 0)
        {
            <em>Members</em>
            <Select Mode="multiple" @bind-Values="@PermissionSelectedUsers" HideSelected TItemValue="string" TItem="string">
                <SelectOptions>
                    @foreach(var PermissionUser in PermissionRemainingUsers)
                    {
                        <SelectOption TItemValue="string" TItem="string" Value="@PermissionUser" Label="@PermissionUser"/>
                    }
                </SelectOptions>
            </Select>
        }

        @if (PermissionRemainingGroups.Count > 0)
        {
            <em>Groups</em>
            <Select Mode="multiple" @bind-Values="@PermissionSelectedGroups" HideSelected TItemValue="string" TItem="string">
                <SelectOptions>
                    @foreach(var PermissionGroup in PermissionRemainingGroups)
                    {
                        <SelectOption TItemValue="string" TItem="string" Value="@PermissionGroup" Label="@PermissionGroup"/>
                    }
                </SelectOptions>
            </Select>
        }
    </Drawer>
    </div>
    }
    
    <div style="float:right"><MatButton Raised="true" Class="mdc-toast-info" OnClick="@(() => { PermissionUserDrawerVisible = true;})">Add User/Group</MatButton></div>
    <Table @ref="PermissionTable"
           TItem="PermissionPayload"
           Size="@TableSize.Small"
           Bordered="true"
           PageSize="10"
           DataSource="@Permissions">
               <Column @bind-Field="@context.UserNameOrGroupName" Title="User or Group" Sortable />
               <Column @bind-Field="@context.FlightData" Title="Flight Data">
                   <AntDesign.Switch @bind-Value="@context.FlightData" OnChange="@(() => { _ = UpdatePermission(context); })"></AntDesign.Switch>
               </Column>
               <Column @bind-Field="@context.BuildingData" Title="Building Data">
                   <AntDesign.Switch @bind-Value="@context.BuildingData" OnChange="@(() => { _ = UpdatePermission(context); })"></AntDesign.Switch>
               </Column>
               <Column @bind-Field="@context.StorageData" Title="Storage Data">
                   <AntDesign.Switch @bind-Value="@context.StorageData" OnChange="@(() => { _ = UpdatePermission(context); })"></AntDesign.Switch>
               </Column>
               <Column @bind-Field="@context.ProductionData" Title="Production Data">
                   <AntDesign.Switch @bind-Value="@context.ProductionData" OnChange="@(() => { _ = UpdatePermission(context); })"></AntDesign.Switch>
               </Column>
               <Column @bind-Field="@context.WorkforceData" Title="Workforce Data">
                   <AntDesign.Switch @bind-Value="@context.WorkforceData" OnChange="@(() => { _ = UpdatePermission(context); })"></AntDesign.Switch>
               </Column>
               <Column @bind-Field="@context.ExpertsData" Title="Experts Data">
                   <AntDesign.Switch @bind-Value="@context.ExpertsData" OnChange="@(() => { _ = UpdatePermission(context); })"></AntDesign.Switch>
               </Column>
               <Column @bind-Field="@context.ContractData" Title="Contract Data">
                   <AntDesign.Switch @bind-Value="@context.ContractData" OnChange="@(() => { _ = UpdatePermission(context); })"></AntDesign.Switch>
               </Column>
               <Column @bind-Field="@context.ShipmentTrackingData" Title="Shipment Tracking">
                   <AntDesign.Switch @bind-Value="@context.ShipmentTrackingData" OnChange="@(() => { _ = UpdatePermission(context); })"></AntDesign.Switch>
               </Column>
               <ActionColumn>
                   <Space>
                       <SpaceItem><Button Danger OnClick="@(()=> { if(!string.IsNullOrEmpty(context.UserName)) { _ = DeletePermission(context.UserName); } else { _ = DeleteGroupPermission(context.GroupNameAndId); } })">Delete</Button></SpaceItem>
                   </Space>
               </ActionColumn>
           </Table>
</FIOWebServer.Components.LoadingWrapper>